export declare enum ConditionOperator {
    STRING_EQUALS = "StringEquals",
    STRING_NOT_EQUALS = "StringNotEquals",
    STRING_EQUALS_IGNORECASE = "StringEqualsIgnoreCase",
    STRING_NOT_EQUALS_IGNORECASE = "StringNotEqualsIgnoreCase",
    STRING_LIKE = "StringLike",
    STRING_NOT_LIKE = "StringNotLike",
    STRING_EQUALS_IFEXISTS = "StringEqualsIfExists",
    STRING_NOT_EQUALS_IFEXISTS = "StringNotEqualsIfExists",
    STRING_EQUALS_IGNORECASE_IFEXISTS = "StringEqualsIgnoreCaseIfExists",
    STRING_NOT_EQUALS_IGNORECASE_IFEXISTS = "StringNotEqualsIgnoreCaseIfExists",
    STRING_LIKE_IFEXISTS = "StringLikeIfExists",
    STRING_NOT_LIKE_IFEXISTS = "StringNotLikeIfExists",
    DATE_EQUALS = "DateEquals",
    DATE_NOT_EQUALS = "DateNotEquals",
    DATE_LESS_THAN = "DateLessThan",
    DATE_LESS_THAN_EQUALS = "DateLessThanEquals",
    DATE_GREATER_THAN = "DateGreaterThan",
    DATE_GREATER_THAN_EQUALS = "DateGreaterThanEquals",
    DATE_EQUALS_IFEXISTS = "DateEqualsIfExists",
    DATE_NOT_EQUALS_IFEXISTS = "DateNotEqualsIfExists",
    DATE_LESS_THAN_IFEXISTS = "DateLessThanIfExists",
    DATE_LESS_THAN_EQUALS_IFEXISTS = "DateLessThanEqualsIfExists",
    DATE_GREATER_THAN_IFEXISTS = "DateGreaterThanIfExists",
    DATE_GREATER_THAN_EQUALS_IFEXISTS = "DateGreaterThanEqualsIfExists",
    NUMERIC_EQUALS = "NumericEquals",
    NUMERIC_NOT_EQUALS = "NumericNotEquals",
    NUMERIC_LESS_THAN = "NumericLessThan",
    NUMERIC_LESS_THAN_EQUALS = "NumericLessThanEquals",
    NUMERIC_GREATER_THAN = "NumericGreaterThan",
    NUMERIC_GREATER_THAN_EQUALS = "NumericGreaterThanEquals",
    NUMERIC_EQUALS_IFEXISTS = "NumericEqualsIfExists",
    NUMERIC_NOT_EQUALS_IFEXISTS = "NumericNotEqualsIfExists",
    NUMERIC_LESS_THAN_IFEXISTS = "NumericLessThanIfExists",
    NUMERIC_LESS_THAN_EQUALS_IFEXISTS = "NumericLessThanEqualsIfExists",
    NUMERIC_GREATER_THAN_IFEXISTS = "NumericGreaterThanIfExists",
    NUMERIC_GREATER_THAN_EQUALS_IFEXISTS = "NumericGreaterThanEqualsIfExists",
    FOR_ANY_VALUE_STRING_LIKE = "ForAnyValue:StringLike",
    FOR_ANY_VALUE_STRING_EQUALS = "ForAnyValue:StringEquals",
    FOR_ALL_VALUES_STRING_LIKE = "ForAllValues:StringLike",
    FOR_ALL_VALUES_STRING_EQUALS = "ForAllValues:StringEquals",
    FOR_ALL_VALUES_STRING_EQUALS_IGNORECASE = "ForAllValues:StringEqualsIgnoreCase",
    BOOL = "Bool",
    BOOL_IFEXISTS = "BoolIfExists",
    BINARY_EQUALS = "BinaryEquals",
    ARN_EQUALS = "ArnEquals",
    ARN_LIKE = "ArnLike",
    ARN_NOT_EQUALS = "ArnNotEquals",
    ARN_NOT_LIKE = "ArnNotLike",
    ARN_EQUALS_IFEXISTS = "ArnEqualsIfExists",
    ARN_LIKE_IFEXISTS = "ArnLikeIfExists",
    ARN_NOT_EQUALS_IFEXISTS = "ArnNotEqualsIfExists",
    ARN_NOT_LIKE_IFEXISTS = "ArnNotLikeIfExists",
    IP_ADDRESS = "IpAddress",
    IP_ADDRESS_IFEXISTS = "IpAddressIfExists",
    NOT_IP_ADDRESS = "NotIpAddress",
    NOT_IP_ADDRESS_IFEXISTS = "NotIpAddressIfExists",
    NULL = "Null"
}
export declare enum StringConditionOperator {
    STRING_EQUALS = "StringEquals",
    STRING_NOT_EQUALS = "StringNotEquals",
    STRING_EQUALS_IGNORECASE = "StringEqualsIgnoreCase",
    STRING_NOT_EQUALS_IGNORECASE = "StringNotEqualsIgnoreCase",
    STRING_LIKE = "StringLike",
    STRING_NOT_LIKE = "StringNotLike",
    STRING_EQUALS_IFEXISTS = "StringEqualsIfExists",
    STRING_NOT_EQUALS_IFEXISTS = "StringNotEqualsIfExists",
    STRING_EQUALS_IGNORECASE_IFEXISTS = "StringEqualsIgnoreCaseIfExists",
    STRING_NOT_EQUALS_IGNORECASE_IFEXISTS = "StringNotEqualsIgnoreCaseIfExists",
    STRING_LIKE_IFEXISTS = "StringLikeIfExists",
    STRING_NOT_LIKE_IFEXISTS = "StringNotLikeIfExists"
}
export declare enum ArnConditionOperator {
    ARN_EQUALS = "ArnEquals",
    ARN_LIKE = "ArnLike",
    ARN_NOT_EQUALS = "ArnNotEquals",
    ARN_NOT_LIKE = "ArnNotLike",
    ARN_EQUALS_IFEXISTS = "ArnEqualsIfExists",
    ARN_LIKE_IFEXISTS = "ArnLikeIfExists",
    ARN_NOT_EQUALS_IFEXISTS = "ArnNotEqualsIfExists",
    ARN_NOT_LIKE_IFEXISTS = "ArnNotLikeIfExists"
}
export declare enum IpAddressConditionOperator {
    IP_ADDRESS = "IpAddress",
    IP_ADDRESS_IFEXISTS = "IpAddressIfExists",
    NOT_IP_ADDRESS = "NotIpAddress",
    NOT_IP_ADDRESS_IFEXISTS = "NotIpAddressIfExists"
}
export declare enum StringMultiValueConditionOperator {
    FOR_ANY_VALUE_STRING_LIKE = "ForAnyValue:StringLike",
    FOR_ALL_VALUES_STRING_LIKE = "ForAllValues:StringLike",
    FOR_ALL_VALUES_STRING_EQUALS = "ForAllValues:StringEquals",
    FOR_ALL_VALUES_STRING_EQUALS_IGNORECASE = "ForAllValues:StringEqualsIgnoreCase",
    FOR_ANY_VALUE_STRING_EQUALS = "ForAnyValue:StringEquals"
}
export declare abstract class OperatorUtils {
    static readonly String: string[];
    static readonly Arn: string[];
    static readonly IpAddress: string[];
    static readonly Date: string[];
    static readonly Numeric: string[];
    static readonly Many: string[];
    static readonly Bool: string[];
    static readonly Binary: string[];
    static operatorIsSupported(supportedOperators: string[], operator: ConditionOperator): boolean | undefined;
    static arraySupport(value: ConditionOperator): boolean;
    static convert(value: any): ConditionOperator;
    static operatorShortName(operator: ConditionOperator): string;
    private constructor();
}
