import { Construct } from 'constructs';
import { Constraint, ConstraintAssembleContext, ConstraintPolicyMutation } from '../constraint';
export declare enum CalledViaServicePrincipal {
    AOSS = "aoss.amazonaws.com",
    ATHENA = "athena.amazonaws.com",
    BACKUP = "backup.amazonaws.com",
    CLOUD9 = "cloud9.amazonaws.com",
    CLOUDFORMATION = "cloudformation.amazonaws.com",
    DATABREW = "databrew.amazonaws.com",
    DATAEXCHANGE = "dataexchange.amazonaws.com",
    DYNAMODB = "dynamodb.amazonaws.com",
    IMAGEBUILDER = "imagebuilder.amazonaws.com",
    KMS = "kms.amazonaws.com",
    MGN = "mgn.amazonaws.com",
    NIMBLE = "nimble.amazonaws.com",
    OMICS = "omics.amazonaws.com",
    RAM = "ram.amazonaws.com",
    ROBOMAKER = "robomaker.amazonaws.com",
    SERVICECATALOG_APPREGISTRY = "servicecatalog-appregistry.amazonaws.com",
    SQLWORKBENCH = "sqlworkbench.amazonaws.com"
}
export declare class CalledViaConstraint extends Constraint {
    private readonly values;
    static calledVia(service: CalledViaServicePrincipal): CalledViaConstraint;
    static calledViaFirst(service: CalledViaServicePrincipal): CalledViaConstraint;
    static calledViaLast(service: CalledViaServicePrincipal): CalledViaConstraint;
    static calledViaFirstAndLast(firstService: CalledViaServicePrincipal, lastService: CalledViaServicePrincipal): CalledViaConstraint;
    private constructor();
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
