import { Construct } from 'constructs';
import { ConditionOperator } from '../condition-operator';
import { Constraint, ConstraintAssembleContext, ConstraintPolicyMutation } from '../constraint';
export declare abstract class ClaimConstraint extends Constraint {
    readonly operator: ConditionOperator;
    readonly claim: string;
    readonly values: string[];
    protected constructor(operator: ConditionOperator, claim: string, values: string[]);
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
export interface PassClaimsConstraintSettings {
    readonly claims: {
        [key: string]: string;
    };
    readonly allowAnyTags: boolean;
    readonly specificallyAllowedTags?: string[];
}
export declare class PassClaimsConstraint extends Constraint {
    readonly settings: PassClaimsConstraintSettings;
    static create(claims: PassClaimsConstraintSettings): PassClaimsConstraint;
    private constructor();
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
