import * as iam from 'aws-cdk-lib/aws-iam';
import { Construct } from 'constructs';
import { IpAddressConditionOperator } from '../condition-operator';
import { Constraint, ConstraintAssembleContext, ConstraintPolicyMutation } from '../constraint';
export declare class SourceIpCidrList {
    readonly cidrs: string[];
    static create(...cidrs: string[]): SourceIpCidrList;
    private constructor();
    toSourceIpConstraint(operator?: IpAddressConditionOperator): SourceIpConstraint;
    applyToPolicy(policy: iam.PolicyStatement, operator?: IpAddressConditionOperator): void;
}
export declare class SourceIpConstraint extends Constraint {
    private readonly operator;
    private readonly cidrList;
    static create(operator: IpAddressConditionOperator, ...cidrs: string[]): SourceIpConstraint;
    static createFromCidrList(operator: IpAddressConditionOperator, cidrList: SourceIpCidrList): SourceIpConstraint;
    static requireSourceFromCidrList(cidrList: SourceIpCidrList): SourceIpConstraint;
    private constructor();
    private validateCidrList;
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
