import { Construct } from 'constructs';
import { Constraint, ConstraintAssembleContext, ConstraintPolicyMutation } from '../constraint';
export declare class StsTransitiveTagKeysConstraint extends Constraint {
    private readonly operator;
    readonly values: string[];
    /**
     * Limit transitive tags to those specified and check for null
     */
    static tagsEqualsAndPresent(value: string, ...values: string[]): StsTransitiveTagKeysConstraint;
    private constructor();
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
export declare class StsCognitoIdentityConstraint extends Constraint {
    readonly identityPoolId: string;
    readonly amr: string;
    static identityPool(identityPoolId: string, amr: string): StsCognitoIdentityConstraint;
    private constructor();
    assemble(scope: Construct, context: ConstraintAssembleContext): ConstraintPolicyMutation[];
}
