import { IClaimsContext } from './claims';
import { PolicyVariable } from './policy-variable';
export interface IIamResourcePath {
    toString(): string;
}
export declare abstract class IamResourcePathBuilder implements IIamResourcePath {
    protected readonly path: string[];
    protected constructor(path: string[]);
    toString(): string;
    protected appendPolicyVariable(policyVariable: PolicyVariable): string[];
    protected appendText(...values: string[]): string[];
}
export interface ClaimsIamResourcePathBuilderSettings {
    readonly claimsContext: IClaimsContext;
}
export declare abstract class ClaimsIamResourcePathBuilder extends IamResourcePathBuilder {
    protected readonly options: ClaimsIamResourcePathBuilderSettings;
    protected constructor(options: ClaimsIamResourcePathBuilderSettings, path: string[]);
    protected appendClaim(...claims: string[]): string[];
    protected appendValue(...values: string[]): string[];
}
export declare class GenericClaimsIamResourcePathBuilder extends ClaimsIamResourcePathBuilder {
    static create(claimsContext: IClaimsContext): GenericClaimsIamResourcePathBuilder;
    private constructor();
    claim(claim: string, ...additionalClaims: string[]): GenericClaimsIamResourcePathBuilder;
    value(value: string, ...additionalValues: string[]): GenericClaimsIamResourcePathBuilder;
    text(value: string, ...additionalValues: string[]): GenericClaimsIamResourcePathBuilder;
    policyVariable(value: PolicyVariable): GenericClaimsIamResourcePathBuilder;
}
