export declare class ResourcePolicyType {
    readonly name: string;
    static readonly API_GATEWAY: ResourcePolicyType;
    static readonly CODE_BUILD: ResourcePolicyType;
    static readonly BACKUP: ResourcePolicyType;
    static readonly KMS: ResourcePolicyType;
    static readonly LAMBDA: ResourcePolicyType;
    static readonly EVENTBRIDGE: ResourcePolicyType;
    static readonly S3: ResourcePolicyType;
    static readonly SECRETS_MANAGER: ResourcePolicyType;
    static readonly GLUE: ResourcePolicyType;
    static readonly SQS: ResourcePolicyType;
    static readonly SNS: ResourcePolicyType;
    static readonly ECR: ResourcePolicyType;
    static readonly STS: ResourcePolicyType;
    private constructor();
}
export declare class PrincipalType {
    readonly type: string;
    static readonly Aws: PrincipalType;
    static readonly Federated: PrincipalType;
    static readonly Saml: PrincipalType;
    static readonly Service: PrincipalType;
    private constructor();
    get isFederated(): boolean;
    get isSaml(): boolean;
    get isService(): boolean;
    get isAws(): boolean;
}
export declare class PolicyType {
    readonly type: string;
    readonly service?: ResourcePolicyType | undefined;
    readonly principalType?: PrincipalType | undefined;
    static readonly NonSpecific: PolicyType;
    static readonly IdentityPolicy: PolicyType;
    static resourcePolicy(type: ResourcePolicyType): PolicyType;
    static trustPolicy(principalType: PrincipalType): PolicyType;
    private constructor();
    get isTrustPolicy(): boolean;
    get isIdentityPolicy(): boolean;
    get isResourcePolicy(): boolean;
    isResourcePolicyForService(service: ResourcePolicyType): boolean;
}
